<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Utilities\Resposta; 
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class ExpImpNfceService {
    
    public $entityManager;
    
   
    
   	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function insertLogArquivoXml($params,$conn=null){
	    if($conn){
                    $connection = $conn;
        }else{
        
            $connection = $this->entityManager->getConnection();
        }
        
        /*
           Particiona o arquivo em partes de tamanho $tam_parte  
           A primeira parte roda com o insert da tabela de log
           As partes seguintes são concatenadas a primeira parte
           Alteração necessária devido a limites no comando CALL Oracle
        */
        $tam_parte = 5000;
        $partes_xml = str_split($params['DSARQXMLNFCE'], $tam_parte);
        $num_partes = count($partes_xml);

        $storedProcedure = new StoredProcedure($connection,'INS_IMPARQXMLNFCE');
           
        $storedProcedure->addParam(new Param('P_NRACESSONFCE',      Param::PARAM_INPUT, $params['NRACESSONFCE'],     Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_DSNOMEARQUIVO',     Param::PARAM_INPUT, $params['DSNOMEARQUIVO'],    Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_DSARQXMLNFCE',      Param::PARAM_INPUT, $partes_xml[0],              Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_DTENTRVENDA',       Param::PARAM_INPUT, $params['DTENTRVENDA'],      Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_CDFILIAL',          Param::PARAM_INPUT, $params['CDFILIAL'],         Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_CDCAIXA',           Param::PARAM_INPUT, $params['CDCAIXA'],          Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_NRORG',             Param::PARAM_INPUT, $params['NRORG'],            Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_CDOPERADOR',        Param::PARAM_INPUT, $params['CDOPERADOR'],       Param::PARAM_TYPE_STR));
        $storedProcedure->addParam(new Param('P_NRIMPARQXMLNFCE',   Param::PARAM_OUTPUT, $params['NRIMPARQXMLNFCE'], Param::PARAM_TYPE_STR,20));
        $storedProcedure->addParam(new Param('P_IDSTATUSIMPARQ',    Param::PARAM_OUTPUT, $params['IDSTATUSIMPARQ'],  Param::PARAM_TYPE_STR,2));
        $storedProcedure->addParam(new Param('P_IDTIPOARQ',         Param::PARAM_OUTPUT, $params['IDTIPOARQ'],       Param::PARAM_TYPE_STR));
        
        $resultado = $storedProcedure->execute();
            
        for($i=1; $i < $num_partes; $i++){
           $storedProcedure = new StoredProcedure($connection,'ANEXA_XML_IMPARQXMLNFCE');
   
           $storedProcedure->addParam(new Param('P_NRIMPARQXMLNFCE',    Param::PARAM_INPUT, $resultado['P_NRIMPARQXMLNFCE'],  Param::PARAM_TYPE_STR));
           $storedProcedure->addParam(new Param('P_DSARQXMLNFCE_PARTE', Param::PARAM_INPUT, $partes_xml[$i],  Param::PARAM_TYPE_STR));
           $storedProcedure->execute();
        }
            
        return $resultado;  
            
    }
    	public function insertMsgLogArquivoXml($params,$conn=null){
    	     if($conn){
                    $connection = $conn;
        }else{
        
            $connection = $this->entityManager->getConnection();
        }

            
           
            
    	    for($i = 0 ; $i < count($params['error']['IDTIPOMSG']); $i++){
    	        
    	           $storedProcedure = new StoredProcedure($connection,'INS_MSGIMPARQXMLNFCE');
    	       
                $storedProcedure->addParam(new Param('P_NRIMPARQXMLNFCE',    Param::PARAM_INPUT, $params['error']['NRIMPARQXMLNFCE'],                Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_IDTIPOMSG',          Param::PARAM_INPUT, $params['error']['IDTIPOMSG'][$i],                  Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_CDFILIAL',           Param::PARAM_INPUT, $params['stFilial'],                                Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_CDCAIXA',            Param::PARAM_INPUT, $params['stCdCaixa'],                               Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_NRNOTAFISCALCE',     Param::PARAM_INPUT, $params['cdsVendaXml']['NRNOTAFISCALCE'],           Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_NRACESSONFCE',       Param::PARAM_INPUT, $params['error']['NRACESSONFCE'],                   Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_CDPRODUTO',          Param::PARAM_INPUT, empty($params['error']['CDPRODUTO'][$i]) ? null : $params['error']['CDPRODUTO'][$i], Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_NMPRODUTO',          Param::PARAM_INPUT, empty($params['error']['NMPRODUTO'][$i]) ? null : $params['error']['NMPRODUTO'][$i], Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_DSERRO',             Param::PARAM_INPUT, $params['error']['DSERRO'][$i],                     Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_DSAJUDA',            Param::PARAM_INPUT, $params['error']['DSAJUDA'][$i],                    Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_CDTIPORECE',         Param::PARAM_INPUT, empty($params['error']['CDTIPORECE'][$i]) ? null : $params['error']['CDTIPORECE'][$i],      Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_NRORG',              Param::PARAM_INPUT, $params['stNrOrg'],                                 Param::PARAM_TYPE_STR));
                $storedProcedure->addParam(new Param('P_CDOPERADOR',         Param::PARAM_INPUT, $params['stCdOperador'],                            Param::PARAM_TYPE_STR));
                
                $storedProcedure->execute();
                
                
    	    }
    	    
            
    }
    
    

    
	
	
	public function executarQueryInsert($query, $params,$conn) {
	    
	    $retorno = new Resposta();
	    
	    $retorno->setParameters($params);
	    try {
	        $resultado = $conn->executeQuery($query, $params);
	        $retorno->setResult($resultado);
	        $retorno->setMessage("Query executada com sucesso. Linhas retornadas: ".$retorno->getLinhasResult());
	        $retorno->setStatus(Resposta::SUCESSO);
	    } catch (\Exception $e){
            $retorno->setMessage($e->getMessage());
            $retorno->setError(true);
            $retorno->setStatus(Resposta::ERRO);
            
        }
        
        return $retorno;
        
	}
	
    
        
    
	public function executarQuery($query, $params,$connection=null) {
	    
	    $retorno = new Resposta();
	    
	    $retorno->setParameters($params);
	    try {
	        if($connection){
	            $resultado = $connection->fetchAll($query, $params);
	        }
	        else{
	            $resultado = $this->entityManager->getConnection()->fetchAll($query, $params);
	        }
	        
	        
	        $retorno->setResult($resultado);
	        $retorno->setMessage("Query executada com sucesso. Linhas retornadas: ".$retorno->getLinhasResult());
	        $retorno->setStatus(Resposta::SUCESSO);
	    } catch (\Exception $e){
            $retorno->setMessage($e->getMessage());
            $retorno->setError(true);
            $retorno->setStatus(Resposta::ERRO);
            
        }
        
        return $retorno;
        
	}
	
	
	//nao sera mais necessario
	//const BUSCAR_URLCHAVE = "SELECT WSSITEUFQRCODENFC FROM WEBSERVICE WHERE SGESTADO = :SGESTADO AND IDSERVICO = :IDSERVICO AND IDAMBIENTE = :IDAMBIENTE";
	
	const BUSCAR_NOTAS = "SELECT * FROM (
	SELECT IDCHECK, CDFILIAL, CDCAIXA, CDLOJA, NRSEQVENDA, DTENTRVENDA, NRACESSONFCE,
       CDSERIE,(CASE WHEN IDTPEMISVEND = 'S' THEN 'SAT' ELSE 'NFCE' END) AS TPEMISVEND, IDTPEMISVEND, NRNOTAFISCALCE, 
       (CASE WHEN IDSITUVENDA = 'O' THEN 'Concluída' ELSE 'Cancelada' END) AS SITUVENDA,IDSITUVENDA, 
       (CASE WHEN IDTPAMBNFCE = '1' THEN 'Produção' ELSE 'Homologação' END) AS TPAMBNFCE,IDTPAMBNFCE, NRPROTOCOLONFCE,DTHRPROTOCONFCE, 
       (CASE WHEN IDSTATUSNFCE = 'A' THEN 'Aceita' ELSE 'Cancelada' END) AS STATUSNFCE, IDSTATUSNFCE,
       NRINSJURIEST, DTHRPROTOCOCANC, DSRAZAOCANCNFCE, NRPROTOCOLOCANC, NRCERTDIGNFCE,
       DSARQXMLNFCE, DSARQXMLCANCNFCE, DSQRCODENFCE, WSSITEUFQRCODENFC, CDVERSAOXMLNFCE, IDORIGEMVENDA, CDINSCESTA, CDIDTOKENPROD, CDIDTOKENHOMO,
       CDCODSCONSPROD, CDCODSCONSHOMO, NMRAZSOCFILI, NRINSJURFILI, DTABERTUR, VRTOTALVENDA, SGESTADO, SUBSTR(DSOBSSTATUSNFCE, 0, 3) AS CODSTATUS,
       SUBSTR(DSOBSSTATUSNFCE, 7) AS DSOBSSTATUSNFCE, CDESTADOIBGE
  FROM (SELECT *
          FROM (SELECT VE.*, ROWNUM LINHA
                  FROM (SELECT 'N' AS IDCHECK, VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, TO_CHAR(VE.DTENTRVENDA, 'DD/MM/YYYY') DTENTRVENDA, VE.NRACESSONFCE,
                               NVL(VE.CDSERIENFCE,VE.CDSERIESAT) AS CDSERIE, VE.IDTPEMISVEND, VE.NRNOTAFISCALCE, VE.IDSITUVENDA, VE.IDTPAMBNFCE, VE.NRPROTOCOLONFCE,
                               VE.DTHRPROTOCONFCE, VE.IDSTATUSNFCE, VE.NRINSJURIEST, VE.DTHRPROTOCOCANC, VE.DSRAZAOCANCNFCE, VE.NRPROTOCOLOCANC, PV.NRCERTDIGNFCE,
                               NVL(AX.DSARQXMLNFCE, VE.DSARQXMLNFCE) AS DSARQXMLNFCE, NVL(AX.DSARQXMLCANCNFCE, VE.DSARQXMLCANCNFCE) AS DSARQXMLCANCNFCE, VE.DSQRCODENFCE, WS.WSSITEUFQRCODENFC, PV.CDVERSAOXMLNFCE, VE.IDORIGEMVENDA,
                               FI.CDINSCESTA, PV.CDIDTOKENPROD, PV.CDIDTOKENHOMO, PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO, FI.NMRAZSOCFILI, FI.NRINSJURFILI, VE.DTABERTUR, VE.VRTOTVENDA AS VRTOTALVENDA, IE.SGESTADO,
                               VE.DSOBSSTATUSNFCE, ES.CDESTADOIBGE
                          FROM PARAVEND PV, VENDA VE, WEBSERVICE WS, ARQXMLNFCESAT AX,(SELECT DISTINCT CDFILIAL, CDCAIXA
                                                         FROM V_FILIALLOJACAIXA F
                                                        WHERE ((INSTR(:P_CDFILIAL, F.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
                                                          AND ((INSTR(:P_CDCAIXA, F.CDFILIAL||F.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))) FC, FILIAL FI, INSCRESTAD IE,  ESTADO ES
                         WHERE FC.CDFILIAL = FI.CDFILIAL
                           AND FC.CDFILIAL = PV.CDFILIAL
                           AND FC.CDFILIAL = VE.CDFILIAL
                           AND FC.CDCAIXA = VE.CDCAIXA
                           AND FI.CDEMPRESA = IE.CDEMPRESA(+)
                           AND FI.CDINSCESTA = IE.CDINSCESTA(+)
                           AND IE.SGESTADO = ES.SGESTADO(+)
                           AND AX.CDFILIAL(+)   = VE.CDFILIAL
                           AND AX.CDCAIXA(+)    = VE.CDCAIXA
                           AND AX.NRSEQVENDA(+) = VE.NRSEQVENDA
                           AND WS.SGESTADO(+) = IE.SGESTADO
                           AND WS.IDSERVICO(+) = 'NFC'
                           AND WS.IDAMBIENTE(+) = :IDTPAMBNFCE
                           AND VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM) VE
                 WHERE ((INSTR(:NRNOTAFISCALCE, VE.NRNOTAFISCALCE) <> 0) OR (:NRNOTAFISCALCE = 'T'))
                   AND ((VE.IDTPEMISVEND = 'N') OR (VE.IDTPEMISVEND = 'S'))
                   AND (INSTR(:P_IDSTATUSNFCE, VE.IDSTATUSNFCE) <> 0)
                   AND VE.IDTPAMBNFCE = :IDTPAMBNFCE
                ORDER BY VE.DTENTRVENDA, VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA) X
          ORDER BY LINHA) REG ) WHERE (CDFILIAL||CDCAIXA||NRSEQVENDA||NRACESSONFCE||CDSERIE||NRNOTAFISCALCE||IDTPAMBNFCE||IDTPEMISVEND||IDSITUVENDA like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )";   
          
          
        const QUERY_GET_FILIAL_NFCE = "SELECT DISTINCT F.CDFILIAL, F.CDEMPRESA, V.CDCAIXA
                                      FROM FILIAL F, VENDA V
                                     WHERE V.IDTPEMISVEND = 'N'
                                       AND V.DTENTRVENDA  > SYSDATE - 30
                                       AND F.CDFILIAL     = V.CDFILIAL
                                       AND F.NRINSJURFILI = :NRINSJURFILI";
        const QUERY_GET_FILIAL_SAT = "SELECT DISTINCT F.CDFILIAL, F.CDEMPRESA, V.CDCAIXA
                                      FROM FILIAL F, VENDA V
                                     WHERE V.IDTPEMISVEND = 'N'
                                       AND V.DTENTRVENDA  > SYSDATE - 30
                                       AND F.CDFILIAL     = V.CDFILIAL
                                       AND F.NRINSJURFILI = :NRINSJURFILI";
   
        const  QUERY_VERIF_VENDA_NFCE = "SELECT CDFILIAL,NRSEQVENDA,CDCAIXA,CDEMPRESA,DTENTRVENDA,CDOPERADOR
                                           FROM VENDA
                                        WHERE CDFILIAL = :CDFILIAL
                                           AND NRNOTAFISCALCE = :NRNOTAFISCALCE
                                           AND CDSERIENFCE = :CDSERIENFCE
                                           AND DTENTRVENDA = :DTENTRVENDA" ;
          const  QUERY_VERIF_VENDA_SAT = "SELECT CDFILIAL,NRSEQVENDA,CDCAIXA,CDEMPRESA,DTENTRVENDA,CDOPERADOR
                                            FROM VENDA
                                         WHERE CDFILIAL = :CDFILIAL
                                            AND NRNOTAFISCALCE = :NRNOTAFISCALCE
                                            AND CDSERIESAT = :CDSERIESAT
                                            AND DTENTRVENDA = :DTENTRVENDA" ;
          const QUERY_VERIF_VENDA_NRACESSONFCE = "SELECT CDFILIAL,NRSEQVENDA, IDSITUVENDA, CDCAIXA,CDEMPRESA,DTENTRVENDA
                                                    FROM VENDA
                                                   WHERE NRACESSONFCE = :NRACESSONFCE";
          const QUERY_VERIF_VENDA_SATCANC = "SELECT CDFILIAL, CDCAIXA, NRSEQVENDA
                                              FROM VENDA
                                             WHERE CDFILIAL     = :CDFILIAL
                                               AND CDCAIXA      = :CDCAIXA
                                               AND NRACESSONFCE = :NRACESSONFCE
                                               AND CDSERIESAT   = :CDSERIESAT
                                               AND DTENTRVENDA  = :DTENTRVENDA";
        const QUERY_VERIF_CAIXA = "SELECT MIN(CDCAIXA) AS CDCAIXA
                                        FROM CAIXA
                                       WHERE CDFILIAL = :CDFILIAL
                                         AND IDCOLETOR <> 'C' " ;
        const QUERY_VERIF_CAIXA_API = "SELECT  CDCAIXA
                                        FROM CAIXA
                                       WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA";
                                         
       const QUERY_GET_SGESTADO = "SELECT SGESTADO FROM ESTADO WHERE CDESTADOIBGE = :CDESTADOIBGE" ;                                  
       const QUERY_VERIF_CONSUMIDOR = "SELECT CL.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDCCUSCLIE, CO.NMCONSUMIDOR 
                                          FROM CONSUMIDOR CO JOIN CLIENTE CL
                                            ON CO.NRCPFRESPCON = :NRINSCRCONS
                                           AND CO.CDCLIENTE = CL.CDCLIENTE";
        const QUERY_GET_CONSUMIDOR_PADRAO = "SELECT CDCLIENTE, '' AS CDCONSUMIDOR, CDCCUSCLIE, '' AS NMCONSUMIDOR
                                              FROM PARAVEND
                                             WHERE CDFILIAL = :CDFILIAL";
        const QUERY_GET_FILIAL = "SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL = :CDFILIAL";
        const QUERY_VERIFICA_ABERTURA = "SELECT DTABERCAIX
                                          FROM TURCAIXA
                                         WHERE CDFILIAL = :CDFILIAL
                                           AND CDCAIXA  = :CDCAIXA
                                           AND :DTVENDA BETWEEN DTABERCAIX AND DTFECHCAIX";
       const QUERY_VERIFICA_LOJA = "SELECT CDLOJA 
                                      FROM CAIXA
                                     WHERE CDFILIAL = :CDFILIAL
                                       AND CDCAIXA  = :CDCAIXA";
        const QUERY_INSERT_TURCAIXA = "INSERT INTO TURCAIXA
                                           (CDFILIAL, CDCAIXA, DTABERCAIX, CDOPERADOR, DTFECHCAIX,
                                            CDOPERABER, CDOPERFECH, DTMOVTURCAIX, DSOBSCAIXA,
                                            IDATUTURCAIXA)
                                        VALUES
                                           (:CDFILIAL, :CDCAIXA, :DTABERCAIX, :CDOPERADOR, :DTFECHCAIX,
                                            :CDOPERADOR, :CDOPERADOR, :DTMOVTURCAIX, :DSOBSCAIXA,
                                            'S')";
        const QUERY_INSERT_VENDA = "INSERT INTO VENDA
                                       (CDFILIAL, CDCAIXA, NRSEQVENDA, CDCLIENTE, CDCCUSCLIE, CDEMPRESA, DTVENDA, DTENTRVENDA, IDSITUVENDA, VRDESCVENDA,
                                        CDFILIALTUR, CDCAIXATUR, DTABERTUR, DTFECHAVENDA, CDLOJA, IDTIPOVENDA, IDTPFORPGVEN,
                                        IDVENDEBCONS, IDCANCMANUAL, NRINSCRCONS, VRTXSEVENDA, VRREPIQUEVENDA,
                                        DSREFENDCONSVEN, NMCONSVEND, CDCONSUMIDOR, NRPESMESAVENDA, DTABERVENDA, IDORIGEMVENDA,
                                        CDPREFINTGCOLVEN, IDIMPVENDA, CDSERIESAT, NRACESSONFCE, IDSTATUSNFCE, NRNOTAFISCALCE, DTEMISSAONFCE, NRLANCTONFCE, IDTPEMISVEND, CDSERIENFCE,
                                        IDTPAMBNFCE, NRINSJURIEST, DTHRPROTOCONFCE, NRPROTOCOLONFCE, DSOBSSTATUSNFCE, DSARQXMLNFCE, SGESTADO)
                                    VALUES
                                       (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :CDCLIENTE, :CDCCUSCLIE, :CDEMPRESA, :DTVENDA, :DTENTRVENDA, :IDSITUVENDA, 0,
                                        :CDFILIAL, :CDCAIXA, :DTABERTUR, :DTFECHAVENDA, :CDLOJA, 'D', 'V',
                                        'N', 'N', :NRINSCRCONS, 0, 0,
                                        'VIA XML', :NMCONSVEND, :CDCONSUMIDOR, '1', :DTABERVENDA, 'BAL_FOS',
                                        'TEK', 'S', :CDSERIESAT, :NRACESSONFCE, 'A', :NRNOTAFISCALCE, :DTVENDA, :NRLANCTONFCE, :IDTPEMISVEND, :CDSERIENFCE,:IDTPAMBNFCE, :NRINSJURIEST,
                                        :DTHRPROTOCONFCE, :NRPROTOCOLONFCE, :DSOBSSTATUSNFCE, NULL, :SGESTADO)";
                                        
        /* não iremos mais inserir o arquivo xml na tabela VENDA, o campo não será mais utilizado devido ao consumo do banco, iremos utilizar apenas na tabela ARQXMLNFCESAT */
        
        const QUERY_INSERT_ARQXML = "INSERT INTO ARQXMLNFCESAT
                                           (CDFILIAL, CDCAIXA, NRSEQVENDA, DSARQXMLNFCE)
                                        VALUES
                                           (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :DSARQXMLNFCE)";
                                        
        const QUERY_GERA_NRSEQVENDA ="SELECT RETORNA_NOVO_CODIGO('PEDIDOVENDA' || :CDFILIAL  || :CDCAIXA, 1, 10) AS NRSEQVENDA
                                 FROM DUAL";
        const QUERY_GERA_NRSEQMOVI = "SELECT RETORNA_NOVO_CODIGO('MOVCAIXA' || :CDFILIAL ||  :CDCAIXA || :DTABERTURACAIXA, 1, 10) AS NRSEQMOVI
                                        FROM DUAL";
        const QUERY_VERIFICA_CODBAR =" SELECT CDBARPRODUTO, CDPRODUTO, CDARVPROD, NMPRODUTO
                                  FROM PRODUTO
                                 WHERE ((CDBARPRODUTO = :CDBARPRODUTO) OR (CDPRODINTE = :CDBARPRODUTO) OR (CDARVPROD = :CDBARPRODUTO))";    
        const QUERY_VERIF_CODBAR_PROD_TAB = "SELECT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO
                                              FROM CDBARRAPROD C, PRODUTO P
                                             WHERE C.CDBARRAPROD = :CDBARRAPROD
                                               AND C.CDPRODUTO   = P.CDPRODUTO";
       const QUERY_VERIF_ALIQ = "SELECT
                                   VRPEALIMPFIS, CDIMPOSTO, IDTPIMPOSFIS, VRALIQCOFINS,
                                   VRALIQPIS, NVL(VRPERCREDUCAO,0) AS VRPERCREDUCAO, CDCSTICMS, CDCSTPISCOF, CDCFOPPFIS
                                FROM
                                   ALIQIMPFIS
                                WHERE
                                   (CDFILIAL  = :CDFILIAL ) AND
                                   (CDPRODUTO = :CDPRODUTO)";
       const QUERY_VERIFI_TIPORECE = "SELECT CDTIPORECE
                                      FROM TIPORECE T
                                     WHERE IDTIPORECE = :IDTIPORECE
                                       AND EXISTS(SELECT 1
                                                    FROM CONFTELACAIXA C, ITMENUCONFTE I
                                                   WHERE C.CDFILICAIXA   = :CDFILIAL
                                                     AND C.CDCAIXA       = :CDCAIXA
                                                     AND C.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) AS DTINIVIGENCIA
                                                                              FROM CONFTELACAIXA
                                                                             WHERE CDFILICAIXA    = :CDFILIAL
                                                                               AND CDCAIXA        = :CDCAIXA
                                                                               AND DTINIVIGENCIA <= TRUNC(SYSDATE))
                                                     AND C.CDFILIAL      = I.CDFILIAL
                                                     AND C.NRCONFTELA    = I.NRCONFTELA
                                                     AND C.DTINIVIGENCIA = I.DTINIVIGENCIA
                                                     AND I.CDIDENTBUTON  = T.CDTIPORECE
                                                     AND I.IDTPBUTTON    = '5')
                                    ORDER BY CDTIPORECE";
       const QUERY_INSERT_ITEMVENDA = " INSERT INTO ITEMVENDA
                                       (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND, VRUNITVEND, VRUNITVENDCL,
                                        VRDESITVEND, CDPRODUTO, CDLOJA, CDORDALIQIMPR, VRALIQIMPR, VRACRITVEND)
                                    VALUES
                                       (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND, :QTPRODVEND, :VRUNITVEND, :VRUNITVENDCL,
                                        :VRDESITVEND, :CDPRODUTO, :CDLOJA, :CDORDALIQIMPR, :VRALIQIMPR, :VRACRITVEND)";
        const QUERY_INSERT_VENDAIMPOS = "INSERT INTO ITVENDAIMPOS
                                           (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, NRSEQITIMPOS, CDIMPOSTO, VRPEALPRODIT, VRIMPOPRODIT, VRPERCOFINS, VRPERPIS,
                                            VRBASECALCREDUZ, VRIMPOPRODREDUZ, VRBASECALCICMS, VRBCREDUZICMS, VRIMPPIS, VRIMPCOFINS, CDCSTPRODI, CDCSTPRODPC,
                                            CDCFOPPROD, VRBCPISCOFINS, VRPRBCREDUICMS)
                                        VALUES
                                           (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND, :NRSEQITIMPOS, :CDIMPOSTO, :VRPEALPRODIT, :VRIMPOPRODIT, :VRPERCOFINS,
                                            :VRPERPIS, :VRBASECALCREDUZ, :VRIMPOPRODREDUZ, :VRBASECALCICMS, :VRBCREDUZICMS, :VRIMPPIS, :VRIMPCOFINS, :CDCSTPRODI, :CDCSTPRODPC,
                                            :CDCFOPPROD, :VRBCPISCOFINS, :VRPRBCREDUICMS)";
        const QUERY_INSERT_MOVCAIXA = "INSERT INTO MOVCAIXA
                                       (CDFILIAL, CDCAIXA, DTABERCAIX, NRSEQUMOVI, IDTIPOMOVIVE, VRMOVIVEND, NRSEQVENDA,
                                        CDTIPORECE, DTHRINCMOV, DTMOVIMCAIXA, CDCLIENTE, IDIMPMOVCAIXA)
                                    VALUES
                                       (:CDFILIAL, :CDCAIXA, :DTABERCAIX, :NRSEQUMOVI, :IDTIPOMOVIVE, :VRMOVIVEND, :NRSEQVENDA,
                                        :CDTIPORECE, :DTHRINCMOV, :DTMOVIMCAIXA, :CDCLIENTE, 'S')";
        const UPDATE_STATUS_IMP_ARQXML = "UPDATE IMPARQXMLNFCE 
                                        SET IDSTATUSIMPARQ = :IDSTATUSIMPARQ , NRSEQVENDA = :NRSEQVENDA
                                WHERE NRACESSONFCE = :NRACESSONFCE"; 
        const UPDATE_VENDA_CANC ="UPDATE VENDA
                                    SET IDSITUVENDA  = 'C',
                                        IDSTATUSNFCE = 'C',
                                        NRACESSOCANC = :NRACESSOCANC
                                  WHERE CDFILIAL   = :CDFILIAL
                                    AND CDCAIXA    = :CDCAIXA
                                    AND NRSEQVENDA = :NRSEQVENDA";
        const UPDATE_MOV_CAIXA_SATCANC = "UPDATE MOVCAIXA
                                           SET IDTIPOMOVIVE = 'C'
                                         WHERE CDFILIAL   = :CDFILIAL
                                           AND CDCAIXA    = :CDCAIXA
                                           AND NRSEQVENDA = :NRSEQVENDA";
        const UPDATE_ARQXML_SATCANC ="UPDATE ARQXMLNFCESAT
                                           SET DSARQXMLCANCNFCE = :DSARQXMLCANC
                                         WHERE CDFILIAL   = :CDFILIAL
                                           AND CDCAIXA    = :CDCAIXA
                                           AND NRSEQVENDA = :NRSEQVENDA";
        const QUERY_CONSULTA_LOGARQ = "SELECT 'Filial - '||A.CDFILIAL AS LABELFILIAL,
                                               1 AS TOTAL,
                                               A.CDFILIAL,
                                               A.CDCAIXA,
                                               A.DSNOMEARQUIVO,
                                               CASE WHEN MIN(A.IDSTATUSIMPARQ) = 'S' THEN  'Importado' ELSE 'Não Importado' END AS IDSTATUSIMPARQ,
                                               CASE WHEN MAX(A.IDTIPOARQ) = 'S' THEN 'SAT' ELSE 'NFC-e' END AS TIPO,
                                               TO_CHAR(A.DTENTRVENDA,'DD/MM/YYYY') AS DTENTRVENDA
                                          FROM IMPARQXMLNFCE A
                                         WHERE ((INSTR(:P_CDFILIAL, A.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
                                           AND ((INSTR(:P_CDCAIXA,A.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))
                                           AND A.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM
                                         GROUP BY 'Filial - '||A.CDFILIAL, A.CDFILIAL, A.CDCAIXA, A.DSNOMEARQUIVO, TO_CHAR(A.DTENTRVENDA, 'DD/MM/YYYY')
                                           " ;
       const QUERY_GET_FILES = "SELECT  * FROM IMPARQXMLNFCE 
                                        WHERE CDFILIAL = :P_CDFILIAL
                                          AND CDCAIXA = :P_CDCAIXA
                                           AND DTENTRVENDA = :P_DTENTRVENDA 
                                           AND DSNOMEARQUIVO = :P_DSNOMEARQUIVO" ;
       
       const QUERY_CONSULTA_LOGMSG = "SELECT DISTINCT (CASE WHEN (M.IDTIPOMSG = 'E') THEN  'Erro' ELSE CASE WHEN (M.IDTIPOMSG = 'A') THEN 'Alerta' END END) AS IDTIPOMSG,
                                        A.DSNOMEARQUIVO,
                                        M.DSERRO,
                                        M.DSAJUDA,
                                        M.NRACESSONFCE,
                                        M.NRNOTAFISCALCE,
                                        M.CDPRODUTO||' - '||M.NMPRODUTO AS NMPRODUTO,
                                        M.CDTIPORECE
                                        FROM MSGIMPARQXMLNFCE M, IMPARQXMLNFCE A
                                        WHERE A.DSNOMEARQUIVO = :DSNOMEARQUIVO  
                                        AND M.CDFILIAL = :P_CDFILIAL 
                                        AND M.CDCAIXA = :P_CDCAIXA
                                        AND M.NRACESSONFCE = A.NRACESSONFCE
                                        ORDER BY M.NRNOTAFISCALCE
                                        ";
                                        
        const QUERY_CONSULTA_ERRO_ALERTA = "SELECT 'Filial - '||A.CDFILIAL AS LABELFILIAL,
                                               (CASE WHEN (COUNT(*) OVER ( PARTITION BY A.NRACESSONFCE )) > 1 THEN 1 ELSE 1 END) AS TOTAL,
                                              A.CDFILIAL,
                                              A.NRIMPARQXMLNFCE,
                                              A.NRACESSONFCE,
                                              A.NRSEQVENDA,
                                              A.CDCAIXA,
                                              (CASE WHEN (A.IDSTATUSIMPARQ = 'N') THEN  'Não Importado' ELSE 'Importado' END) AS IDSTATUSIMPARQ,
                                              A.DSNOMEARQUIVO,'NFC-e' AS TIPO, TO_CHAR(A.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA ,
                                              (CASE WHEN (M.IDTIPOMSG = 'E') THEN  'Erro' ELSE CASE WHEN (M.IDTIPOMSG = 'A') THEN 'Alerta' ELSE CASE WHEN (M.IDTIPOMSG = 's') THEN 'Importado' END END END) AS IDTIPOMSG,M.DSERRO,M.DSAJUDA, M.NRNOTAFISCALCE, M.CDPRODUTO||' - '||M.NMPRODUTO AS NMPRODUTO, M.CDTIPORECE
                                              FROM IMPARQXMLNFCE A
                                              LEFT JOIN (SELECT * FROM MSGIMPARQXMLNFCE) M 
                                                                                      ON  
                                                                                       M.NRIMPARQXMLNFCE = A.NRIMPARQXMLNFCE 
                                                                                      AND M.CDFILIAL = A.CDFILIAL 
                                                                                      AND M.CDCAIXA = A.CDCAIXA
                                                                                      AND M.NRACESSONFCE = A.NRACESSONFCE
                                               WHERE ((INSTR(:P_CDFILIAL, A.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
                                               AND ((INSTR(:P_CDCAIXA,A.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))
                                                AND A.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM
                                                AND M.IDTIPOMSG IS NOT NULL
                                                ";
        const QUERY_FILIAL_EMPRESA = "SELECT CDFILIAL,CDEMPRESA,NRINSJURFILI
                                FROM FILIAL
                               WHERE 
                               CDFILIAL = :CDFILIAL";
       const QUERY_GET_OPERADOR = "SELECT MIN(CDOPERADOR) AS CDOPERADOR FROM OPERADOR WHERE NRORG = :NRORG";
                                                    
}


