<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelConsolidacaoPendente {

	public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($CDOPERADOR, $CDFILIAL, $CDCAIXA, $DTINI, $DTFIN, $TODASNF, $NRORG) {
    $params = array(
      ":CDOPERADOR" => $CDOPERADOR,
      ":CDFILIAL" => $CDFILIAL,
     	":TCDFILIAL" => $CDFILIAL,
      ":CDCAIXA" => $CDCAIXA,
      ":TCDCAIXA" => $CDCAIXA,
      ":DTINI" => $DTINI,
      ":DTFIN" => $DTFIN,
      ":TODASNF" => $TODASNF,
     	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_CONSOLIDACAO_VENDA_PENDENTE, $params);
  }
    
  const GET_CONSOLIDACAO_VENDA_PENDENTE = "
    SELECT DISTINCT  V.CDFILIAL||' - '||FILIOPERLOJACAIX.NMFILIAL||' Loja: '||V.CDLOJA||' - '||FILIOPERLOJACAIX.NMLOJA AS LABELFILIAL, V.CDCAIXA||' - '||FILIOPERLOJACAIX.NMCAIXA AS LABELCAIXA, 
           V.CDFILIAL, FILIOPERLOJACAIX.NMFILIAL, V.CDLOJA, FILIOPERLOJACAIX.NMLOJA, V.CDCAIXA, FILIOPERLOJACAIX.NMCAIXA, 
           NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS NRNOTAFISCALCE, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA, TO_DATE(V.DTVENDA, 'DD/MM/YYYY HH24:MI:SS') AS DTVENDA,
           '1' AS  TOTALDIA
      FROM VENDA V
      JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILIOPERLOJA.CDFILIAL, FILIOPERLOJA.NMFILIAL, FILIOPERLOJA.CDLOJA, FILIOPERLOJA.NMLOJA, FILIOPERLOJA.NRORG
              FROM CAIXA C
              JOIN (SELECT L.CDLOJA, L.NMLOJA, FILIOPER.CDFILIAL, FILIOPER.NMFILIAL, FILIOPER.NRORG
                      FROM LOJA L
                      JOIN (SELECT FO.CDFILIAL, F.NMFILIAL, FO.NRORG
                              FROM FILIAL F
                              JOIN (SELECT FO.CDFILIAL, FO.NRORG
                                      FROM FILIOPER FO
                                     WHERE FO.CDOPERADOR = :CDOPERADOR
                                       AND FO.NRORG = :NRORG
                                   ) FO
                                ON F.CDFILIAL = FO.CDFILIAL
                               AND F.NRORG = FO.NRORG
                           )FILIOPER
                        ON FILIOPER.CDFILIAL = L.CDFILIAL
                       AND FILIOPER.NRORG = L.NRORG
                   )FILIOPERLOJA
                ON FILIOPERLOJA.CDFILIAL = C.CDFILIAL
               AND FILIOPERLOJA.CDLOJA = C.CDLOJA
               AND FILIOPERLOJA.NRORG = C.NRORG 
           )FILIOPERLOJACAIX
        ON FILIOPERLOJACAIX.CDFILIAL = V.CDFILIAL
       AND FILIOPERLOJACAIX.CDCAIXA = V.CDCAIXA
       AND FILIOPERLOJACAIX.CDLOJA = V.CDLOJA
       AND FILIOPERLOJACAIX.NRORG = V.NRORG
      JOIN ITEMVENDA I
        ON V.CDFILIAL = I.CDFILIAL
       AND V.CDCAIXA = I.CDCAIXA
       AND V.NRSEQVENDA = I.NRSEQVENDA
       AND V.NRORG = I.NRORG
      LEFT OUTER JOIN LANCTOESTOQ LC
        ON I.CDFILIALNF = LC.CDFILIAL
       AND I.NRLANCTONF = LC.NRLANCTONF
       AND LC.NRLANCESTQ IS NOT NULL
     WHERE V.NRORG = :NRORG
       AND V.DTENTRVENDA BETWEEN NVL(:DTINI,SYSDATE-30) AND NVL(:DTFIN,SYSDATE)
       AND V.IDSITUVENDA IN ('O','D')
       AND I.CDFILIALEST IS NULL
       AND I.NRLANCESTQ IS NULL
       AND (INSTR(:CDFILIAL, V.CDFILIAL) > 0 OR (:TCDFILIAL = 'T'))
       AND (INSTR(:CDCAIXA, V.CDFILIAL||V.CDCAIXA) > 0 OR (:TCDCAIXA = 'T'))
  ";
}